import FreeCAD
import FreeCADGui
import pivy.coin


# ViewProviderAssemblyPy.xml
class ViewProviderAssembly(FreeCADGui.ViewProvider):
    """This is the ViewProviderAssembly class"""

    @property
    def DraggerPlacement(self) -> FreeCAD.Placement:
        """Placement of the assembly dragger object."""

    @DraggerPlacement.setter
    def DraggerPlacement(self, value: FreeCAD.Placement):
        """
        Placement of the assembly dragger object.
        Possible exceptions: (TypeError).
        """

    @property
    def DraggerVisibility(self) -> bool:
        """Show or hide the assembly dragger."""

    @property
    def EnableMovement(self) -> bool:
        """Enable moving the parts by clicking and dragging."""

    @property
    def MoveInCommand(self) -> bool:
        """If enabled, each move will be wrapped in a command."""

    @property
    def MoveOnlyPreselected(self) -> bool:
        """If enabled, only the preselected object will move."""

    def getDragger(self) -> pivy.coin.SoDragger:
        """
        Return the assembly dragger coin object.

                      getDragger() -> SoFCCSysDragger

                      Returns: dragger coin object of the assembly
        """

    def isInEditMode(self) -> bool:
        """
        Return true if the assembly object is currently in edit mode.

                      isInEditMode() -> bool
        """
