import typing

import FreeCAD
import MatGui


# MaterialTreeWidgetPy.xml
class MaterialTreeWidget(FreeCAD.BaseClass):
    """
    This class can be imported.
    Material tree widget.
    """

    @typing.overload
    def __init__(self): ...

    @typing.overload
    def __init__(self, obj: MatGui.MaterialTreeWidget, /): ...

    @typing.overload
    def __init__(self, obj, /):
        """
        Material tree widget.
        Possible exceptions: (TypeError).
        """

    @property
    def IncludeEmptyFolders(self) -> bool:
        """Include empty folders in the material list."""

    @IncludeEmptyFolders.setter
    def IncludeEmptyFolders(self, value: bool): ...

    @property
    def IncludeEmptyLibraries(self) -> bool:
        """Include empty libraries in the material list."""

    @IncludeEmptyLibraries.setter
    def IncludeEmptyLibraries(self, value: bool): ...

    @property
    def IncludeFavorites(self) -> bool:
        """Include favorites in the material list."""

    @IncludeFavorites.setter
    def IncludeFavorites(self, value: bool): ...

    @property
    def IncludeLegacy(self) -> bool:
        """Include legacy materials in the material list."""

    @IncludeLegacy.setter
    def IncludeLegacy(self, value: bool): ...

    @property
    def IncludeRecent(self) -> bool:
        """Include recently used materials in the material list."""

    @IncludeRecent.setter
    def IncludeRecent(self, value: bool): ...

    @property
    def UUID(self) -> str:
        """Material UUID."""

    @UUID.setter
    def UUID(self, value: str): ...

    @property
    def expanded(self) -> bool:
        """Expand material tree."""

    @expanded.setter
    def expanded(self, value: bool): ...

    def selectFilter(self, name: str, /):
        """Set the current material filter."""

    def setFilter(self, obj, /):
        """Set the material filter or list of filters."""
